
//--------------------------------------------------------------
// VS4U
//--------------------------------------------------------------

#ifndef _VS4U_H_
#define _VS4U_H_

//--------------------------------------------------------------
// }N`
//--------------------------------------------------------------
#define M_PI			(3.14159265358979323846)

#define VS4U_MAX_PATH	(260)	// pX̒

#define VS4U_PBSIZE		(65536)	// sb`xhf[^pobt@TCY(120BPM̏ꍇ341b)

//#define PRINT_TIME			// ԕ\
//#define PRINT_OPTION			// IvV\


//--------------------------------------------------------------
// \̒`
//--------------------------------------------------------------

// IvVȂǕKvȃf[^VS4UOPTIONɒ`
typedef struct{
	// t@C
	char inputWaveFile[VS4U_MAX_PATH];	// WAVEt@C
	char outputWaveFile[VS4U_MAX_PATH];	// oWAVEt@C
	char frqFile[VS4U_MAX_PATH];		// Wg\t@C
	char vsfrqFile[VS4U_MAX_PATH];		// Ǝg\t@C
	char vspFile[VS4U_MAX_PATH];		// vWFNgt@C(fobOp)

	// IvV
	int noteNum;				// o͉K[m[gio[(C4=60)]
	double offset;				// ItZbg[ms]
	double reqLength;			// v[ms]
	double fixedLength;			// q[ms]
	double endBlank;			// uN[ms](̏ꍇAItZbg̑Βl)
	double fixSpeed;			// qx(02{,1001{,2000.5{)

	double volume;				// {[[%](0`200)
	double modulation;			// W[V[%](-200`200)
	double tempo;				// e|[BPM](10`512)
	int nPitchBend;				// sb`xhf[^	
	int pitchBend[VS4U_PBSIZE];	// sb`xhf[^[cent](-2048`2047)
								// (c[gĎsہAɂĂ͓Imۂ
								//    s邱Ƃ邽߃X^bNmہB͕s)

	int noFormantFlg;			// tH}gȂtO	("N",lOFF)
	int genderFactor;			// WF_[t@N^[[-20cent]("g",-100`100,l0)
	int pitchShift;				// sb`[10cent]			("t",-240`240,l0)
	int pitchShift2;			// sb`[1cent]			("T",-2400`2400,l0)
	int peekCmp;				// s[NRvbT			("P",0`100,l86)
	int lowPassfilter;			// [pXtB^				("H",0`99,l0)
	int breathiness;			// uVlX					("B",0`100,l50)
	int brightness;				// uCglX					("O",-100`100,l0)
	int clearness;				// NAlX					("S",-100`100,l0)
	int outputVshpFlg;			// VSHPo̓tO				("Z",lOFF)
	int reGenerateFrqFlg;		// g\č쐬tO			("V",lOFF)
	int disablePitchShift;		// sb`VtgtO		("W",{l0)
								//	-2:a[h,PS -1:P[h,PS 0:PSL

	// p
	short *tmpWaveData;			// ꎞf[^
	int tmpSample;				// ꎞf[^Tv
	int tmpSmpFreq;				// ꎞf[^̃TvOg
} VS4UOPTION;

// gf[^
typedef struct{
	double freq;
	double dyn;
} FREQDATA;


//--------------------------------------------------------------
// vg^Cv錾
//--------------------------------------------------------------

// 
double LimitDoubleValue( double value, double min, double max );
int LimitIntValue( int value, int min, int max );
void AddExtStr( char *dstStr, int dstSize, char *extStr );
int CheckFileExist( char *fileName );

// IvVݒ
int Vs4uGetOption( int argc, char *argv[], VS4UOPTION *option );
int Vs4uCnvNoteNum( char *nnStr );
int Vs4uSetFlgOption( char *flgStr, VS4UOPTION *option );
int Vs4uDecodeBase64( char *str );
int Vs4uSetPitchBendOption( char *argv[], VS4UOPTION *option );
void Vs4uPrintOption( VS4UOPTION *option );

// sb`AtH}gA^C~O
int Vs4uStep1( VS4UOPTION *option );
HVSPRJ Vs4uLoadProject( VS4UOPTION *option );
int Vs4uSetTimeStretchPrm( HVSPRJ hVsprj, VS4UOPTION *option );
int Vs4uLoadFrqFile( HVSPRJ hVsprj, VS4UOPTION *option );
int Vs4uCalcAveragePit( HVSPRJ hVsprj, VS4UOPTION *option );
int Vs4uSetPitPrm( HVSPRJ hVsprj, VS4UOPTION *option );

// [pXtB^A{[
int Vs4uStep2( VS4UOPTION *option );
int Vs4uLowPassFilter( VS4UOPTION *option );
int Vs4uVolume( VS4UOPTION *option );
int Vs4uOutputWaveFile( VS4UOPTION *option );

#endif /* _VS4U_H_ */

