
//--------------------------------------------------------------
// VS4U sb`AtH}gA^CXgb`
//--------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <windows.h>

#include "vslib.h"
#include "vs4u.h"


//--------------------------------------------------------------
// sb`VtgAtH}gVtgA^CXgb`
//
// 
//  VS4UOPTION *option	IvV
//
// ߂l
//  0: 1:s
//
// Tv
//  sb`VtgAtH}gVtgA^CXgb`sB
//  (inputWaveFiletmpWaveData)
//--------------------------------------------------------------
int Vs4uStep1( VS4UOPTION *option )
{
	VSPRJINFO vsPrjInfo;
	VSITEMINFO vsItemInfo;

	// vWFNg쐬
	HVSPRJ hVsprj = Vs4uLoadProject( option );
	if( hVsprj == NULL )
	{
		return 1;
	}

	// ^CXgb`ݒ
	Vs4uSetTimeStretchPrm( hVsprj, option );

	// sb`ݒ
	Vs4uSetPitPrm( hVsprj, option );

	// ݒ
	if( option->disablePitchShift == -2 )
	{
		// a[hɐݒ
		VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
		vsItemInfo.synthMode = SYNTHMODE_P;
		VslibSetItemInfo( hVsprj, 0, &vsItemInfo );
	}
	else
	{
		if( option->noFormantFlg != 0 )
		{
			// tH}gȂȂP[hɐݒ
			VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
			vsItemInfo.synthMode = SYNTHMODE_M;
			VslibSetItemInfo( hVsprj, 0, &vsItemInfo );
		}
		else
		{
			// tH}g␳ȂPtH}g␳[hɐݒ
			VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
			vsItemInfo.synthMode = SYNTHMODE_MF;
			VslibSetItemInfo( hVsprj, 0, &vsItemInfo );
		}
	}

	// EQݒ
	int eq1[15] = { 0, 0, 0, 0, 0, 0, 0, 20, 60, 100, 120, 120, 80,   0,   0 };
	int eq2[15] = { 0, 0, 0, 0, 0, 0, 0,  0,  0,   0,   0,   0, 40, 120, 120 };
	VslibSetEQGain( hVsprj, 0, 0, eq1 );
	VslibSetEQGain( hVsprj, 0, 1, eq2 );

	// _擾
	VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
	int nCtrlPnt = vsItemInfo.ctrlPntNum;
	
	// _p[^ݒ
	for( int i=0; i<nCtrlPnt; i++ ){
		// _擾
		VSCPINFOEX vsCpInfo;
		VslibGetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
		
		// WF_[t@N^[ݒ
		vsCpInfo.formant = -20*option->genderFactor;

		// uVlXݒ
		vsCpInfo.breathiness = (option->breathiness-50)*200;

		// uCglXݒ
		vsCpInfo.eq1 = option->brightness*100;

		// NAlXݒ
		vsCpInfo.eq2 = option->clearness*100;

		// _ݒ
		VslibSetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
	}

	// TvOgATv擾
	VslibGetProjectInfo( hVsprj, &vsPrjInfo );
	option->tmpSmpFreq = vsPrjInfo.sampFreq;
	VslibGetMixSample( hVsprj, &option->tmpSample );

	// WAVEf[^擾
	option->tmpWaveData = (short *)calloc( option->tmpSample, sizeof(short) );
	VslibGetMixData( hVsprj, option->tmpWaveData, 16, 1, 0, option->tmpSample );

	// vWFNgt@Co
	if( option->outputVshpFlg == 12345 ){
		VslibSaveProject( hVsprj, option->vspFile );
	}

	// vWFNg폜
	VslibDeleteProject( hVsprj );

	return 0;
}


//--------------------------------------------------------------
// vWFNg쐬
//
// 
//  VS4UOPTION *option	IvV
//
// ߂l
//  vWFNgnh
//
// Tv
//  Ǝg\ǂݍ݁AvWFNgnhԂB
//  Ǝg\Ȃꍇ͍쐬B
//  sꍇNULLԂB
//--------------------------------------------------------------
HVSPRJ Vs4uLoadProject( VS4UOPTION *option )
{
	int sta;

	// WAVEt@C݃`FbN
	if( CheckFileExist( option->inputWaveFile ) == 0 ){
		printf( "VS4U:̓t@C܂.\n" );
		return NULL;
	}

	// Wg\݃`FbN
	int existFrqFlg = CheckFileExist( option->frqFile );

	// Ǝg\݃`FbN
	int existVsfrqFlg = CheckFileExist( option->vsfrqFile );

	// vWFNg쐬 ----------------------------------------
	HVSPRJ hVsprj = NULL;

	if( option->reGenerateFrqFlg != 0 ){
		existVsfrqFlg = 0;
	}
	else{
		if( existVsfrqFlg != 0 ){
			// Ǝg\ǂݍ
			sta = VslibOpenProject( &hVsprj, option->vsfrqFile );
			if( sta != VSERR_NOERR ){
				printf( "VS4U:g\ǂݍ݃G[.\n" );
				existVsfrqFlg = 0;
			}
		}
	}

	if( existVsfrqFlg == 0 ){
		// Ǝg\(vsp)쐬
		printf( "VS4U:g\쐬܂.\n" );

		// vWFNg쐬
		sta = VslibCreateProject( &hVsprj );
		if( sta != VSERR_NOERR ){
			printf( "VS4U:G[.\n" );
			return NULL;
		}
		
		// ACeǉ
		int itemNum;
		sta = VslibAddItemEx( hVsprj, option->inputWaveFile, &itemNum,  36, 48, 0 );
		if( sta != VSERR_NOERR ){
			printf( "VS4U:t@C̓G[.\n" );
			return NULL;
		}

		// Wg\𗘗pĎgݒ
		if( existFrqFlg != 0 ){
			Vs4uLoadFrqFile( hVsprj, option );
		}

		// Ǝg\ۑ
		sta = VslibSaveProject( hVsprj, option->vsfrqFile );
		if( sta != VSERR_NOERR ){
			printf( "VS4U:g\̕ۑɎs܂.\n" );
		}
		else{
			printf( "VS4U:g\쐬܂.\n" );
		}
	}

	return hVsprj;
}


//--------------------------------------------------------------
// Wg\𗘗pĎgݒ
//
// 
//  HVSPRJ hVsprj	vWFNg
//  VS4UOPTION *option	IvV
//
// ߂l
//  0: 1:s
//
// Tv
//  Wg\𗘗păsb`͒lݒ肷B
//--------------------------------------------------------------
int Vs4uLoadFrqFile( HVSPRJ hVsprj, VS4UOPTION *option )
{
	VSPRJINFO vsPrjInfo;
	VSITEMINFO vsItemInfo;
	int retVal = 0;

	FILE *fpFrq;
	fopen_s( &fpFrq, option->frqFile, "rb" );

	if ( fpFrq != NULL ){
		// f[^Ԋu[Tv]
		int itvSmp = 256;
		fseek( fpFrq, 8, SEEK_SET );
		fread( &itvSmp, sizeof(int), 1, fpFrq );
		
		// L[g
		double keyFreq = 440.0;
		fseek( fpFrq, 12, SEEK_SET );
		fread( &keyFreq, sizeof(double), 1, fpFrq );

		// f[^
		int nData = 0;
		fseek( fpFrq, 36, SEEK_SET );
		fread( &nData, sizeof(int), 1, fpFrq );

		// gf[^
		FREQDATA *freqData = (FREQDATA *)calloc( nData, sizeof(FREQDATA) );
		fseek( fpFrq, 40, SEEK_SET );
		fread( freqData, sizeof(FREQDATA), nData, fpFrq );

#if 0
		// \(fobOp)
		printf( "itvSmp=%d\n", itvSmp );
		printf( "keyFreq=%f\n", keyFreq );
		printf( "nData=%d\n", nData );
		for( int i=0; i<nData; i++ ){
			printf( "%f,%f; ", freqData[i].freq, freqData[i].dyn );
		}
		getchar();
#endif

		// _擾
		VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
		int nCtrlPnt = vsItemInfo.ctrlPntNum;

		// TvOg擾
		VslibGetProjectInfo( hVsprj, &vsPrjInfo );
		int sampFreq = vsPrjInfo.sampFreq;
		double cpSec = 1.0/vsItemInfo.ctrlPntPs;	// _̕b

		// gݒ
		for( int i=0; i<nCtrlPnt; i++ ){
			// Wg\ł̃|CgZo
			double smp = i*cpSec*sampFreq;
			int pnt = (int)(smp/itvSmp);

			// gݒ
			double freq = 0.0;
			if( ( pnt >= 0 ) && ( pnt < nData ) ){
				freq = freqData[pnt].freq;
			}

			if( freq > 55.0 ){	// sb`
				// ҏWOsb`ƃsb`LtOݒ
				VSCPINFOEX vsCpInfo;
				VslibGetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
				vsCpInfo.pitOrg = (int)(log(freq/440.0)/log(2.0)*1200.0)+6900;
				vsCpInfo.pitFlgEdit = 1;
				VslibSetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
			}
			else{				// sb`Ȃ
				// ҏWOsb`ƃsb`LtOݒ
				VSCPINFOEX vsCpInfo;
				VslibGetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
				vsCpInfo.pitOrg = (int)(log(keyFreq/440.0)/log(2.0)*1200.0)+6900;
				vsCpInfo.pitFlgEdit = 0;
				VslibSetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
			}
		}
		
		// gf[^
		free( freqData );
		freqData = NULL;

		// t@C
		fclose( fpFrq );
	}
	else{
		retVal = 1;
	}

	return retVal;
}


//--------------------------------------------------------------
// ^CXgb`ݒ
//
// 
//  HVSPRJ hVsprj	vWFNg
//  VS4UOPTION *option	IvV
//
// ߂l
//  0:
//
// Tv
//  ^CXgb`p[^ݒ肷B
//--------------------------------------------------------------
int Vs4uSetTimeStretchPrm( HVSPRJ hVsprj, VS4UOPTION *option )
{
	VSPRJINFO vsPrjInfo;
	VSITEMINFO vsItemInfo;

	// TvOg擾
	VslibGetProjectInfo( hVsprj, &vsPrjInfo );
	int sampFreq = vsPrjInfo.sampFreq;

	// ACe擾
	VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
	double orgSmp = vsItemInfo.sampleOrg;					// ̃Tv
	double offsetSmp = option->offset*0.001*sampFreq;		// ItZbg̃Tv
	double fixedSmp = option->fixedLength*0.001*sampFreq;	// q̃Tv
	double endBlankSmp = option->endBlank*0.001*sampFreq;	// uÑTv
	double reqSmp = option->reqLength*0.001*sampFreq;		// ṽTv

	// uN(ItZbg̑Βl)ȂI[̃uNɕϊ
	if( endBlankSmp < 0 ){
		endBlankSmp = orgSmp-offsetSmp+endBlankSmp;
	}

	// q̃Xgb`{
	double fixStretch = pow( 2.0, 1.0-option->fixSpeed/100.0 );

	// ^C~O_ǉ
	if( reqSmp >= fixedSmp*fixStretch ){
		// vqȏ
		VslibSetTimeCtrlPnt( hVsprj, 0, 1, (int)orgSmp, (int)reqSmp );
		VslibAddTimeCtrlPnt( hVsprj, 0, (int)(orgSmp-endBlankSmp), (int)reqSmp );
		VslibAddTimeCtrlPnt( hVsprj, 0, (int)(offsetSmp+fixedSmp), (int)(fixedSmp*fixStretch) );
		VslibAddTimeCtrlPnt( hVsprj, 0, (int)offsetSmp, 0 );
	}
	else{
		// vq
		VslibSetTimeCtrlPnt( hVsprj, 0, 1, (int)orgSmp, (int)reqSmp );
		VslibAddTimeCtrlPnt( hVsprj, 0, (int)(offsetSmp+reqSmp/fixStretch), (int)reqSmp );
		VslibAddTimeCtrlPnt( hVsprj, 0, (int)offsetSmp, 0 );
	}

	return 0;
}


//--------------------------------------------------------------
// ꉹ̃sb`ϒlvZ
//
// 
//  HVSPRJ hVsprj	vWFNg
//  VS4UOPTION *option	IvV
//
// ߂l
//  0:
//
// Tv
//  ꉹ̃sb`ϒlvZvZB
//--------------------------------------------------------------
int Vs4uCalcAveragePit( HVSPRJ hVsprj, VS4UOPTION *option )
{
	VSITEMINFO vsItemInfo;

	// _擾
	VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
	int nCtrlPnt = vsItemInfo.ctrlPntNum;

	// _̕bZo
	double ctrpntSec = 1.0/vsItemInfo.ctrlPntPs;

	// ꉹԂ̐_ԍZo
	int startPnt = (int)((option->offset+option->fixedLength)*0.001/ctrpntSec);
	int endPnt = (int)(nCtrlPnt-option->endBlank*0.001/ctrpntSec);
	startPnt = LimitIntValue( startPnt, 0, nCtrlPnt );
	endPnt = LimitIntValue( endPnt, 0, nCtrlPnt );

	// ꉹ̃sb`ϒlZo
	int pitSum = 0;
	int count = 0;
	for( int i=startPnt; i<endPnt; i++ ){
		VSCPINFOEX vsCpInfo;
		VslibGetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
		if( vsCpInfo.pitFlgEdit == 1 ){	// sb`镔̂݃JEg
			pitSum += vsCpInfo.pitOrg;
			count++;
		}
	}
	int pitAverage = 6000;
	if( count != 0 ){
		pitAverage = pitSum/count;
	}

	// ꉹ̃sb`ϒlZo(2)
	pitSum = 0;
	count = 0;
	for( int i=startPnt; i<endPnt; i++ ){
		VSCPINFOEX vsCpInfo;
		VslibGetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
		if( vsCpInfo.pitFlgEdit == 1 ){	// sb`镔̂݃JEg
			if( abs(vsCpInfo.pitOrg-pitAverage) < 200 ){
				pitSum += vsCpInfo.pitOrg;
				count++;
			}
		}
	}
	pitAverage = 6000;
	if( count != 0 ){
		pitAverage = pitSum/count;
	}

	return pitAverage;
}


//--------------------------------------------------------------
// sb`ݒ
//
// 
//  HVSPRJ hVsprj	vWFNg
//  VS4UOPTION *option	IvV
//
// ߂l
//  0:
//
// Tv
//  sb`p[^ݒ肷B
//--------------------------------------------------------------
int Vs4uSetPitPrm( HVSPRJ hVsprj, VS4UOPTION *option )
{
	VSPRJINFO vsPrjInfo;
	VSITEMINFO vsItemInfo;

	// TvOg擾
	VslibGetProjectInfo( hVsprj, &vsPrjInfo );
	int sampFreq = vsPrjInfo.sampFreq;

	// _擾
	VslibGetItemInfo( hVsprj, 0, &vsItemInfo );
	int nCtrlPnt = vsItemInfo.ctrlPntNum;

	// _̕bvZ
	double ctrpntSec = 1.0/vsItemInfo.ctrlPntPs;

	// sb`ϒlvZ
	int pitAverage = Vs4uCalcAveragePit( hVsprj, option );

	// Ŝɂsb`VtgʂvZ
	int globalShift = 10*option->pitchShift+option->pitchShift2;
	
	// sb`xhl̊Ԋu[bP]vZ
	double pbitvSec = 256.0/sampFreq;
	if( option->tempo > 0.0 ){
		pbitvSec = 60.0/option->tempo/96;	// 41/96̕b
	}

	if( ( option->disablePitchShift == -1 ) || ( option->disablePitchShift == -2 ) )
	{
		for( int i=0; i<nCtrlPnt; i++ ){
			// sb`ݒ
			VSCPINFOEX vsCpInfo;
			VslibGetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
			vsCpInfo.pitEdit = vsCpInfo.pitOrg;
			VslibSetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
		}
	}
	else
	{
		// ҏWsb`p[^ݒ ------------------------------
		for( int i=0; i<nCtrlPnt; i++ ){
			// ҏẄʒu(bP)vZ
			double edtSec;
			VslibGetStretchEditSec( hVsprj, 0, i*ctrpntSec, &edtSec );
		
			// sb`xhlvZ
			int bendPnt = (int)(edtSec/pbitvSec);
			int bend = 0;
			if( ( bendPnt >= 0 ) && ( bendPnt < option->nPitchBend ) ){
				bend = option->pitchBend[bendPnt];
			}

			// sb`ݒ
			VSCPINFOEX vsCpInfo;
			VslibGetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
			int modPit = (int)((vsCpInfo.pitOrg-pitAverage)*option->modulation/100.0);
			vsCpInfo.pitEdit = option->noteNum*100+modPit+bend+globalShift;
			VslibSetCtrlPntInfoEx( hVsprj, 0, i, &vsCpInfo );
		}

	
		// ҏWsb`p[^(VS4Up)ݒ --------------------
		// o̓Tv擾
		int mixSample;
		VslibGetMixSample( hVsprj, &mixSample );

		// sb`xhf[^Zo
		double mixSec = (double)mixSample/sampFreq;
		int nPitchBend = (int)(mixSec/pbitvSec)+1;

		// sb`xhf[^sb`ύX[cent]ɕϊ
		for( int i=0; i<nPitchBend; i++ ){
			// sb`xhf[^̈ʒuɑΉ鐧_ԍvZ
			double orgSec;
			double edtSec = LimitDoubleValue( i*pbitvSec, 0.0, mixSec );
			VslibGetStretchOrgSec( hVsprj, 0, edtSec, &orgSec );
			int pnt = LimitIntValue( (int)(orgSec/ctrpntSec), 0, nCtrlPnt-1 );

			// ҏWOsb`擾
			VSCPINFOEX vsCpInfo;
			VslibGetCtrlPntInfoEx( hVsprj, 0, pnt, &vsCpInfo );
			int pitOrg = vsCpInfo.pitOrg;

			// ҏWsb`vZ
			int modPit = (int)((pitOrg-pitAverage)*option->modulation/100.0);
			int pitEdt = option->noteNum*100+modPit+globalShift+option->pitchBend[i];

			// sb`ύXʂZbg
			option->pitchBend[i] = pitEdt-pitOrg;
		}

		// sb`ύXʃf[^ݒ
		VslibSetPitchArray( hVsprj, 0, option->pitchBend, nPitchBend, pbitvSec*sampFreq );
	}

	return 0;
}

