
//--------------------------------------------------------------
// VS4UC
//--------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>
#include <windows.h>

#include "vslib.h"
#include "vs4u.h"


//--------------------------------------------------------------
// C
//--------------------------------------------------------------
int main( int argc, char *argv[] )
{
	// Tv\
	if( argc <= 1 ){
		printf( "----------------------------------------\n" );
		printf( "VS4U ver.1.32\n" );
		printf( "Copyright (C) 2013-2014 [\n" );
		printf( "http://ackiesound.ifdef.jp/\n" );
		printf( "----------------------------------------\n" );
		return 0;
	}

#ifdef PRINT_TIME
	// JnԎ擾
	int time_start = GetTickCount();
#endif

	// IvVݒ
	VS4UOPTION option;
	if( Vs4uGetOption( argc, argv, &option ) != 0 ){
		return 0;
	}

	// IvV\
#ifdef PRINT_OPTION
	Vs4uPrintOption( &option );
#endif

	// sb`AtH}gA^CXgb`
	if( Vs4uStep1( &option ) != 0 ){
		return 0;
	}

	// tB^A{[
	if( Vs4uStep2( &option ) != 0 ){
		return 0;
	}

#ifdef PRINT_TIME
	// IԎ擾
	int time_end = GetTickCount();

	// ԕ\
	printf( "VS4U:o͊ :%dms\n", time_end-time_start );
#else
	printf( "VS4U:o͊\n" );
#endif

	return 0;
}

